#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n,k;
    cin>>n;
    vector <int> a;
    int dp[n];
    int sl=0;
    for (int i=0;i<n;i++)
    {
        cin>>k;
        if (k!=1)
        {
            if (k!=2)
            {
                sl=1;
            }
        }
        a.push_back(k);
        if (i==0)
        {
            dp[i]=0;
        }
        else
        {
            if (a[i-1]>a[i])
            {
                dp[i]=dp[i-1]+1;
            }
            else
            {
                dp[i]=dp[i-1];
            }
        }
    }
    //cout<<sl<<endl;
    if (sl==1)
    {
        int q;
        cin>>q;
        int l,r;
        for (int i=0;i<q;i++)
        {
            cin>>l>>r;
            int tren=dp[r-1] - dp[l-1];
            if (tren>1)
            {
                cout<<"NE"<<endl;
            }
            else
            {
                cout<<"DA"<<endl;
            }
        }
    }
    else if (sl==0)
    {
        int q;
        cin>>q;
        int l,r;
        vector <int> b;
        for (int i=0;i<q;i++)
        {
            cin>>l>>r;
            int du=r-l+1;
            int broj1[du];
            int broj2[du];
            int p=1;
            for (int j=l-1;j<=r-1;j++)
            {
                b.push_back(a[j]);
            }
            if (b[0]==1)
            {
                broj1[0]=1;
                broj2[0]=0;
            }
            else
            {
                broj1[0]=0;
                broj2[0]=1;
            }
            for (int j=1;j<b.size();j++)
            {
                if (b[j]==1)
                {
                    broj1[j]=broj1[j-1]+1;
                    broj2[j]=broj2[j-1];
                }
                else
                {
                    broj2[j]=broj2[j-1]+1;
                    broj1[j]=broj1[j-1];
                }
            }

            int poz1,poz2;
            auto it=find(b.begin(),b.end(),2);
            if (it!=b.end())
            {
                poz2=it-b.begin();
                auto it1=find(it,b.end(),1);
                {
                    if (it1!=b.end())
                    {
                        poz1=it1-b.begin();
                        //cout<<poz1<<" "<<poz2<<endl;
                        int br2=broj2[poz1]-broj2[poz2-1]; //broj dvojki do prve jedinice (ako ima vise od 1 dvojke pre prve jedinice a posle nje vise od jedna jedinica ne moze
                        int br1=broj1[b.size()-1] - broj1[poz1-1]; //broj jedinica posle prve dvojke
                        //cout<<br1<<" "<<br2<<endl;
                        if (br2>1 and br1>1)
                        {
                            cout<<"NE"<<endl;
                        }
                        else
                        {
                            if (br2==1)
                            {
                               auto it3=find(it+1,b.end(),2);
                               int poz22=it3-b.begin();
                               if (it3!=b.end())
                               {
                                   int br11=broj1[poz22]-broj1[poz2-1];
                                   //cout<<br11<<endl;
                                   if (br11==1)
                                   {
                                       if (br1==1)
                                       {
                                           cout<<"NE"<<endl;
                                       }
                                       else
                                       {
                                            cout<<"NE"<<endl;
                                       }
                                   }
                                   else
                                   {
                                       if (br1==br11)
                                       {
                                           cout<<"DA"<<endl;
                                       }
                                       else
                                       {
                                           cout<<"NE"<<endl;
                                       }
                                   }
                               }
                               else
                               {
                                   cout<<"DA"<<endl;
                               }
                            }
                            else
                            {
                                cout<<"NE"<<endl;
                            }
                        }

                    }
                    else
                    {
                        cout<<"DA"<<endl;
                    }
                }



            }
            else
            {
                cout<<"DA"<<endl;
            }





                b.clear();
        }

    }
}